# Dump for Glossary + Article Ideas

## Article Ideas:
- Compilers
- Computer Theory
- Databases
- Web Frontend
- Datastructures and Algorithms
- Filesystems
- Time
- Software Security
- Realtime Networking
- Cryptography
- Compression
- Memory Allocation
- Parallel Programming
- UI / UX Design
- GPU programming
- Machine Learning
- Control Theory

## MetaHubs 
(places to start branching people from to get to the outlines)
- Operating System
- Web
- Game Dev

# Rough Categorization Beyond Here
## Compiler Terms:
- SSA
- Basic Blocks
- Peephole Optimization
- Parser-Generators
- Regular Grammars
- BNF
- Context-Free Grammars
- Automata
- Regular Expressions
- Interpreters
- JIT

## Computer Theory Terms:
- Conway's Game of Life
- Turing Machines
- Lambda Calculus
- Finite State Machines
- Monads
- Complexity Theory

## Database Terms:
- SQL
- NoSQL
- GraphQL
- CAP theorem
- B-Trees

## Web Frontend Terms:
- REST
- JSON
- WASM
- AJAX

## Datastructures and Algorithms Terms:
(Should this be split across domains? Should this just be a central datastructures thing?)
- A*
- BFS
- DFS
- Greedy
- Priority Queue
- Stack
- Radix Sorting
- Quicksort
- Timsort
- Ring Buffers
- Merkle Trees
- Consensus algorithms
- Directed Acyclic Graphs
- Binary Trees
- Skip lists
- Bloom filters
- Hashmaps

## Filesystems Terms:
- Journalling
- BTrees
- Raw Flash vs Disk Sectors vs NVMe

## Time Terms:
- NTP
- Time Skewing / Slurring / Smearing

## Security Terms:
- Trampolines
- ROP chains
- Buffer overflow
- Hypervisor
- Containers

## Realtime Networking / Network Simulation Terms:
- VLAN
- Rollback
- Opus
- ICE/STUN/TURN
- NAT
- P2P

## Cryptography, Hashing and Error Correction Terms:
- PKCS
- RSA
- SHA
- ECC
- CRC Family
- FNV
- Pseudorandom numbers

## Compression Terms:
- Burrows-Wheeler Transform
- RLE Compression
- Wavelet Transforms

## Memory Terms:
- NUMA regions
- Cache Locality
- Buddy Allocator
- Pool
- Arenas
- Stack
- Heap
- DMA
- Page Tables (virtual memory)

## Parallelism Terms:
- CAS
- Mutex
- Semaphore
- RW Locks
- Memory Barriers
- CSP

## UI/UX Terms:
- Dark Patterns

## Number Theory Terms:
(should this be embedded in other topics?)
- Birthday Paradox

# Needed Glossary Terms
## HTTP to PHY Terms:
- HTTP
- TCP
- UDP
- QUIC
- DNS
- IP
- Ethernet
- ARP
- TLS
- DHCP